<template>
  <div class="wrapper">

    <div class="header">
      <div
        :style="`background-image: url(${require('@/assets/img/arrow-back.svg')})`"
        @click="$store.commit('TOGGLE_AUTH_MENU', { status: false })"
        class="arrow-back-button"
      >
      </div>
      Авторизация
    </div>

    <div v-if="$store.state.tips.auth" class="tip">
      Введите номер телефона и полученный смс-код
      <div @click="$store.commit('SET_TIP_STATUS', { tip: 'auth', status: false })" :style="`background-image: url(${require('@/assets/img/cross.svg')})`" class="cross-icon">
      </div>
    </div>

    <div class="input-wrapper">
      <input
        class="input"
        type="tel"
        @input="onSendPhone()"
        placeholder="Номер телефона"
        v-model="phone"
        v-mask="'+7 (###) ### ## ##'"
        ref="phone"
        maxlength="18"
      />
    </div>

    <div class="input-wrapper">
      <input
        @input="onSendCode()"
        class="input"
        type="tel"
        placeholder="Код из смс"
        v-model="code"
        v-mask="'####'"
      />
    </div>

    <div style="width: 70%; color: #84DCE1; padding: 17px 20px 17px;">
      Ввод смс - кода является вашим согласием с правилами в <a style="color: #84DCE1" href="http://example.org">договоре присоединения</a> 
    </div>

  </div>
</template>

<script>
import { mask } from "vue-the-mask";
import { debounce } from "debounce";

export default {
  directives: {
    mask,
  },
  data() {
    return {
      phone: '',
      key: '',
      code: '',
    }
  },
  props: {
    isTipOpen: Boolean,
  },
  mounted() {
    setTimeout(() => {
      this.$refs.phone.focus();
    }, 1000);
  },
  methods: {
    onSendPhone: debounce(function () {
      this.sendPhone();
      
    }, 1000),

    async sendPhone() {
      
      if (this.phone.length === 18) {
        try {
          const formatPhone = this.phone.replace(/\W/g, '');
          
          await this.$store.dispatch('GET_USER_KEY', { phone: formatPhone });

        } catch (e) {
          console.log('Ошибка при получении ОТП кода', e);
        } 
      }
    },

    onSendCode: debounce(function() {
      this.sendCode();
      
    }, 1000),

    async sendCode() {
      if (this.code.length === 4) {
        try {
          // const body = {
          //   phone: this.phone.replace(/\W/g, ''),
          //   key: this.key,
          //   otp: this.code
          // }
          await this.$store.dispatch('CHECK_PIN_CODE', { code: this.code })

        } catch (e) {
          console.log('Ошибка при получении ОТП кода', e);
        } 
      }
    },

    // authValidation(e) {
    //   // здесь в будущем допишу что надо, а пока так
    //   if (e.target.value.length === 4) {
    //     this.$emit('authSuccess');
    //   }
    // }
  }
};
</script>

<style scoped>
@import '../styles/styles.css';
</style>